# 最終課題 "Ballon Popping"

Copyright &copy; 2022 Takumi Okada. All right reserved.

## **初めに**

システム設定でキーボードの入力速度を最大に、入力間隔を最大にしてください。

＊*設定をしていないとPCが動かなくなる可能性があります(重すぎて)*

## **変数など**

***

### 使用画像リスト(フリー画像)

```python
bI=[
    'ballon_w.PNG',
    'ballon_r.PNG',
    'ballon_s.PNG',
    'ballon_g.PNG'
]

PI=[
    'PI0.PNG',
    'PI1.PNG',
    'PI2.PNG',
    'PI3.PNG',
    'PI4.PNG',
    'PI5.PNG'
]
```

### 風船の出現場所, 当たり判定, 風船の情報

```python
bl=[[35,55],[250,470],[540,100],[880,470],[1090,55]]
bcd=[[30,30,52,28],[20,20,36,14],[16,14,28,12],[13,12,21,9]]
ballon=[[],[],[],[],0]
```

### playerの動作制御

```python
N=[0,0,0,0,0,0,0,0]
rm=False
lm=False
janp=False
```

### player情報

```python
pl=[100,494,0,0,"R",'RS',0,1]
#pl0:x座標,pl1:y座標,pl2:x軸移動速度(4),pl3:y軸移動速度(10),pl4:向き,pl5:tag,pl6:階,pl7:床判定
ps=6
#playerの速度
```

### 弾情報

```python
bu=[3,20,300]
#bu0:半径,bu1,速度,bu2:射程
B=[[],[],[],[],[],0,0,0]
#B0:tag,B1:x座標,B2:xの初期座標,B3:y座標,B4:向き,B5:Bc,B6:Wait,B7:delete回数
```

***

## **class一覧**

***

### 足場

```python
class Scaffolding:
    def __init__(self,x1,y1,x2,y2,color):
        self.x1=x1
        self.y1=y1
        self.x2=x2
        self.y2=y2
        self.color=color
        self.scaffolding=None

    def S_display(self,canvas):
        canvas.create_rectangle(self.x1,self.y1,self.x2,self.y2,outline=self.color,fill=self.color)
```

### 風船

```python
class Ballon:
    def b_create(canvas):
        global ballon,BALLON,bl,bcd
        ballon[4]=ballon[4]+1
        c=r.randint(0,4)
        while c==ballon[0][ballon[4]-1]:
            c=r.randint(0,4)
        ballon[0].append(c)
        ballon[1].append(r.randint(0,3))
        ballon[2].append(tk.PhotoImage(file=bI[ballon[1][ballon[4]]]).subsample(10+5*ballon[1][ballon[4]]))
        ballon[3].append("ballon"+''.join(str(ballon[4])))
        canvas.create_image(bl[ballon[0][ballon[4]]][0],bl[ballon[0][ballon[4]]][1],
                                image=ballon[2][ballon[4]],tag=ballon[3][ballon[4]])
        label_ballon.config(text="score:"+str(ballon[4]))
```

### 動き

```python
class PM:
    def move():
        global rm,lm,janp,player,N
        def loop_M():
            global rm,lm,janp,player,N,Lm
            if rm==True or lm==True or janp==True or pl[7]==0:
                canvas.delete(pl[5])
                if pl[0]>=1200-120 or pl[0]<=45:
                    pl[2]=0
                if pl[1]<=294 and pl[6]==0:
                    janp=False
                    pl[7]=0
                elif pl[1]<=144 and pl[6]==1:
                    janp=False
                    pl[7]=0
                elif pl[1]<=0:
                    janp=False
                    pl[7]=0
                elif ((150-15<pl[0]<350+15 and 430<pl[1]<440) or
                (370-15<pl[0]<760+15 and 280<pl[1]<290) or
                (780-15<pl[0]<980+1 and 430<pl[1]<440)):
                    janp=False
                    pl[7]=0
                if pl[7]==0 and janp==False:
                    pl[3]=10
                pl[0]=pl[0]+pl[2]
                pl[1]=pl[1]+pl[3]
                if (pl[1]>=490 or
                (150-35<pl[0]<350+35 and 390-52<pl[1]<390-45) or
                (370-35<pl[0]<760+35 and 240-52<pl[1]<240-45) or
                (780-35<pl[0]<980+35 and 390-52<pl[1]<390-45)):
                    pl[3]=0
                    pl[7]=1
                    N[3]=0
                    if pl[1]>=490:
                        pl[6]=0
                        janp=False
                    elif (150-30<pl[0]<350+30 and 390-52<pl[1]<390-45) or (780-30<pl[0]<980+30 and 390-52<pl[1]<390-45):
                        pl[6]=1
                        janp=False
                    elif 370-30<pl[0]<760+30 and 240-52<pl[1]<240-45:
                        pl[6]=2
                        janp=False
                    if pl[4]=="R" and rm==False:
                        player=tk.PhotoImage(file=PI[0]).subsample(11)
                        pl[5]='RS'
                    if pl[4]=="L" and lm==False:
                        player=tk.PhotoImage(file=PI[5]).subsample(10)
                        pl[5]='LS'
                else:
                    pl[7]=0
                    N[3]=1
                canvas.create_image(pl[0],pl[1],image=player,tag=pl[5])
            
            Lm=GR.after(10,loop_M)
        GR.after(10,loop_M)   

    def RM_S(event):
        global rm,pl,player
        rm=True
        pl[2]=ps
        pl[4]="R"
        player=tk.PhotoImage(file=PI[2]).subsample(8)
        pl[5]='RM'

    def LM_S(event):
        global lm,pl,player
        lm=True
        pl[2]=-ps
        pl[4]="L"
        player=tk.PhotoImage(file=PI[4]).subsample(17)
        pl[5]='LM'

    def RM_E(event):
        global rm,pl,player
        rm=False
        pl[2]=0
        pl[4]="R"
        player=tk.PhotoImage(file=PI[0]).subsample(11)
        pl[5]='RS'
        if pl[0]>=1200-120:
            pl[0]=pl[0]-ps
        canvas.create_image(pl[0],pl[1],image=player,tag=pl[5])

    def LM_E(event):
        global lm,pl,player
        lm=False
        pl[2]=0
        pl[4]="L"
        player=tk.PhotoImage(file=PI[5]).subsample(10)
        pl[5]='LS'
        if pl[0]<=45:
            pl[0]=pl[0]+ps
        canvas.create_image(pl[0],pl[1],image=player,tag=pl[5])

    def Janp(event):
        global rm,lm,janp,pl,player,N
        if N[3]==0:
            janp=True
            pl[3]=-10
            N[3]=1
            if pl[4]=="R" and rm==False:
                player=tk.PhotoImage(file=PI[1]).subsample(10)
                pl[5]='RJ'
            if pl[4]=="L" and lm==False:
                player=tk.PhotoImage(file=PI[3]).subsample(22)
                pl[5]='LJ'
```

### 射撃

```python
class Shot:
    def shot(event):
        global B,N,Full
        def relode():
            global B
            B[6]=B[6]+1
            if B[6]!=2:
                GR.after(1000,relode)
            if B[6]==2:
                for j in range(0,30):
                    canvas.delete(B[0][j])
                for i in range(0,5):
                    B[i].clear()
                B[5]=0
                B[6]=0
                B[7]=0
                N[6]=N[6]+1
                label_RB.config(text="残弾数:"+(str(30-B[5])+"/"+str(30*(2-N[6]))))

        def full():
            global B,Full
            if Full==True and B[5]<30:
                B[5]=B[5]+1
                t="T"+''.join([r.choice('0123456789ABCDEF') for i in range(10)])
                if pl[4]=="R":
                    x=pl[0]+50
                elif pl[4]=="L":
                    x=pl[0]-50
                if rm==False and lm==False:
                    y=pl[1]-33
                else:
                    y=pl[1]-14
                B[0].append(t)
                B[1].append(x)
                B[2].append(x)
                B[3].append(y)
                B[4].append(pl[4])
                label_RB.config(text="残弾数:"+(str(30-B[5])+"/"+str(30*(2-N[6]))))
                if B[5]<30:
                    GR.after(100,full)
                if B[5]==30 and N[6]<3:
                    GR.after(0,relode)
                return B

        if N[4]==0:
            if B[5]<30:
                B[5]=B[5]+1
                t="T"+''.join([r.choice('0123456789ABCDEF') for i in range(10)])
                if pl[4]=="R":
                    x=pl[0]+50
                elif pl[4]=="L":
                    x=pl[0]-50
                if rm==False and lm==False:
                    y=pl[1]-33
                else:
                    y=pl[1]-14
                B[0].append(t)
                B[1].append(x)
                B[2].append(x)
                B[3].append(y)
                B[4].append(pl[4])
                label_RB.config(text=("残弾数:"+str(30-B[5])+"/"+str(30*(2-N[6]))))
                if B[5]==30 and N[6]<3:
                    GR.after(0,relode)
            return B

        elif N[4]==1:
            if N[5]==0:
                Full=True
                N[5]=1
            GR.after(1,full)
            
    def full_stop(event):
        global Full
        Full=False
        N[5]=0

    def ModeC(event):
        global N
        if N[4]==0:
            N[4]=1
        elif N[4]==1:
            N[4]=0

    def Relode(event):
        def relode():
            global B,N
            B[6]=B[6]+1
            if B[6]!=2:
                GR.after(1000,relode)
            if B[6]==2:
                for j in range(0,len(B[0])):
                    canvas.delete(B[0][j])
                for i in range(0,5):
                    B[i].clear()
                B[5]=0
                B[6]=0
                B[7]=0
                N[6]=N[6]+1
                label_RB.config(text=(str(30-B[5])+"/"+str(30*(2-N[6]))))
        if N[6]<3 and B[5]!=0:
            GR.after(0,relode)

    def loop_shot():
        global score,ballon,bl,bcd,Ls
        for j in range(0,B[5]):
            canvas.delete(B[0][j])
            if (B[4][j]=="R" and B[1][j]<B[2][j]+bu[2]):
                canvas.create_oval(B[1][j]-bu[0],B[3][j]-bu[0],B[1][j]+bu[0],B[3][j]+bu[0],fill="#D7D700",width=0,tag=B[0][j])
                B[1][j]=B[1][j]+bu[1]
                if B[1][j]>B[2][j]+bu[2]-bu[1]:
                    B[4][j]=0
                    B[7]=B[7]+1
            elif (B[4][j]=="L" and B[1][j]>B[2][j]-bu[2]):
                canvas.create_oval(B[1][j]-bu[0],B[3][j]-bu[0],B[1][j]+bu[0],B[3][j]+bu[0],fill="#D7D700",width=0,tag=B[0][j])
                B[1][j]=B[1][j]-bu[1]
                if B[1][j]<B[2][j]-bu[2]+bu[1]:
                    B[4][j]=0
                    B[7]=B[7]+1
            if ((B[4][j]=="R" or B[4][j]=="L") and 
            (bl[ballon[0][ballon[4]]][0]-bcd[ballon[1][ballon[4]]][0]<B[1][j]<bl[ballon[0][ballon[4]]][0]+bcd[ballon[1][ballon[4]]][1] and 
            bl[ballon[0][ballon[4]]][1]-bcd[ballon[1][ballon[4]]][2]<B[3][j]<bl[ballon[0][ballon[4]]][1]+bcd[ballon[1][ballon[4]]][3])):
                canvas.delete(ballon[3][ballon[4]])
                Ballon.b_create(canvas)
        Ls=GR.after(10,Shot.loop_shot)
```

***

## **event**

***

```python

GR.bind("<Key-d>",PM.RM_S)
GR.bind("<KeyRelease-d>",PM.RM_E)
GR.bind("<Key-a>",PM.LM_S)
GR.bind("<KeyRelease-a>",PM.LM_E)
GR.bind("<KeyRelease-w>",PM.Janp)
GR.bind("<Button-1>",Shot.shot)
GR.bind("<ButtonRelease-1>",Shot.full_stop)
GR.bind("<KeyRelease-c>",Shot.ModeC)
GR.bind("<KeyRelease-r>",Shot.Relode)

```

***

## 追記

すべて自作です。
